import java.util.LinkedList;

/**

 The EdgeList class extends the LinkedList class to provide a linked list
 capability to be used only for Edge objects. The default methods are overriden
 only where necessary for the assignment.

 @author SJSU Students
 
 */

public class EdgeList extends LinkedList 
{

	public boolean add(Object o)
	{
		if (isEdge(o, "add"))
			super.add(o);

		return true; // As per the general contract of Collection.add.
	}

	public boolean contains(Object o)
	{
		if (isEdge(o, "contains"))
		{
			int index = this.indexOf(o);
			return (index != -1);
		}
		else
			return false;
	}

	public int indexOf(Object o)
	{
		if (isEdge(o, "indexOf"))
		{
			for (int index = 0; index < this.size(); index++)
				if (((Edge) o).equals((Edge) this.get(index))) return index;
		}
		return -1;
	}

	public boolean remove(Object o)
	{
		if (isEdge(o, "remove"))
		{
			int index = this.indexOf(o);
			if (index != -1)
			{
				super.remove(index);
				return true;
			}
		}
		return false;
	}

	/**
	 This method is a helper for the methods overriden in this class. It simply
	 checks to see that the input is an Edge object, and prints an error message
	 if it is not.
	 @param o the object to be checked
	 @param procedureName the name of the procedure calling isEdge
	 @return true iff o is an Edge object
	 */
	private boolean isEdge(Object o, String procedureName)
	{
		if(!(o instanceof Edge))
		{
			System.out.println("ERROR: EdgeList." + procedureName
					+ " called with a non-Edge object.");
			return false;
		}
		return true;
	}
}
