/**

 The Matching class is the main entry point for CS254 Hw1, problem 4.

 @author SJSU Students

 */
public class Matching 
{

	/**
	 This is the main entry method for the assignment. The input strings
	 represent an instance of the BIPARTITE-MATCHING problem. This method
	 creates a flow graph based on the reduction to MAX-FLOW, pretty prints the
	 capacity matrix of the graph, computes a "reverse" flow graph using the
	 max-flow algorithm, pretty prints the capacity matrix of that graph, and
	 finally prints YES or NO depending on if the original input represented a
	 graph that has a bipartite matching.
	 */
	public static void main(String[] args)
	{
		FlowGraph graph = new FlowGraph(args);

		// Print the capacity matrix of the initial graph.
		System.out.println("Initial capacity matrix:");
		graph.printCapacityMatrix();

		// Get the flow.
		int flow = graph.calculateFlow();

		// Print the capacity matrix of the modified flow graph.
		System.out.println("\n");
		System.out.println("Max-flow capacity matrix:");
		graph.printCapacityMatrix();

		// Print the final result.
		System.out.println("\n");
		if (flow == args.length)
			System.out.println("YES, there is a matching.");
		else
			System.out.println("NO, there is not a matching.");
	}

}
